const QLS_ALL_LOCALES = "af-ZA#am-ET#ar-AE#ar-BH#ar-DZ#ar-EG#ar-IQ#ar-JO#ar-KW#ar-LB#ar-LY#ar-MA#ar-OM#ar-QA#ar-SA#ar-SY#ar-TN#ar-YE#arn-CL#as-IN#ast-ES#az-AZ-Cyrl#az-AZ-Latn#ba-RU#be-BY#ber-DZ#bg-BG#bn-IN#bo-BT#bo-CN#br-FR#bs-BA-Cyrl#bs-BA-Latn#ca-AD#ca-ES#ca-FR#co-FR#cs-CZ#cy-GB#da-DK#de-AT#de-CH#de-DE#de-LI#de-LU#div-MV#el-GR#en-AU#en-BZ#en-CA#en-CB#en-GB#en-IE#en-IN#en-JA#en-MY#en-NZ#en-PH#en-SG#en-TT#en-US#en-ZA#en-ZW#es-AR#es-BO#es-CL#es-CO#es-CR#es-DO#es-EC#es-ES#es-ES-ts#es-GT#es-HN#es-MX#es-NI#es-PA#es-PE#es-PR#es-PY#es-SV#es-UR#es-US#es-VE#et-EE#eu-ES#fa-IR#fi-FI#fil-PH#fo-FO#fr-BE#fr-CA#fr-CH#fr-FR#fr-LU#fr-MC#fur-IT#fy-NL#ga-IE#gbz-AF#gl-ES#gsw-FR#gu-IN#ha-NG-Latn#he-IL#hi-IN#hr-BA#hr-HR#hu-HU#hy-AM#id-ID#ii-CN#is-IS#it-CH#it-IT#iu-CA-Cans#iu-CA-Latn#ja-JP#ja-JP-mac#ka-GE#kk-KZ#kl-GL#km-KH#kn-IN#kok-IN#ko-KR#ky-KG#lb-LU#lo-LA#lt-LT#lv-LV#mi-NZ#mk-MK#ml-IN#mn-CN#mn-MN#moh-CA#mr-IN#ms-BN#ms-MY#mt-MT#nb-NO#ne-NP#nl-BE#nl-NL#nn-NO#ns-ZA#oc-FR#or-IN#pa-IN#pl-PL#ps-AF#pt-BR#pt-PT#qut-GT#quz-BO#quz-EC#quz-PE#rm-CH#ro-RO#ru-RU#rw-RW#sah-RU#sa-IN#se-FI#se-NO#se-SE#si-LK#sk-SK#sl-SI#sma-NO#sma-SE#smj-NO#smj-SE#smn-FI#sms-FI#sq-AL#sr-BA-Cyrl#sr-BA-Latn#sr-SP-Cyrl#sr-SP-Latn#sv-FI#sv-SE#sw-KE#syr-SY#ta-IN#te-IN#tg-TJ-Cyrl#th-TH#tk-TM#tn-ZA#tr-IN#tr-TR#tt-RU#ug-CN#uk-UA#ur-PK#uz-UZ-Cyrl#uz-UZ-Latn#vi-VN#wee-DE#wen-DE#wo-SN#xh-ZA#yo-NG#zh-CHS#zh-CHT#zh-CN#zh-HK#zh-MO#zh-SG#zh-TW#zu-ZA";
const QLS_DEFAULT_LOCALES = "en-US#nl-NL#fr-FR#it-IT#es-ES#ja-JP#de-DE#pt-PT#zh-CN#ru-RU#zh-TW";

addEventListener("load",Init,true);
addEventListener("unload",DeInit,false);

function Init()
{
	if (!this.QLSIsInitialized)
	{
		this.QLSPrefObserver = 
		{
			observe: function(subject, topic, prefName)
			{
				if (topic == "nsPref:changed" && prefName == "general.useragent.locale")
				{
					if (typeof(CheckLocale) == 'function') CheckLocale();
				}
			}
		};
		this.QLSSettingsObserver =
		{
			observe: function(subject, topic, state)
			{
				if (topic == "qls-settings" && state == 'OK') ApplySettings();
			}
		}

		var oPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
		oPrefService.addObserver("general.useragent.locale", this.QLSPrefObserver, false);

		this.oPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("general.useragent.");
		this.oQLSPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.qls.");
		this.oALPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("intl.");
		this.oSCPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("spellchecker.");

		this.oLastFocusedElement = null;

		if (!this.oQLSPref.prefHasUserValue("notifyrestart")) this.oQLSPref.setBoolPref("notifyrestart", true);
		if (!this.oQLSPref.prefHasUserValue("askautorestart")) this.oQLSPref.setBoolPref("askautorestart", true);

		if (!this.oQLSPref.prefHasUserValue('locale')) SetQLSPref("locale", GetLocale());

		if (!this.oQLSPref.prefHasUserValue('customlocale1')) SetQLSPref("customlocale1", "");
		if (!this.oQLSPref.prefHasUserValue('customlabel1')) SetQLSPref("customlabel1", "");
		if (!this.oQLSPref.prefHasUserValue('customlocale2')) SetQLSPref("customlocale2", "");
		if (!this.oQLSPref.prefHasUserValue('customlabel2')) SetQLSPref("customlabel2", "");
		if (!this.oQLSPref.prefHasUserValue('customlocale3')) SetQLSPref("customlocale3", "");
		if (!this.oQLSPref.prefHasUserValue('customlabel3')) SetQLSPref("customlabel3", "");

		if (!this.oQLSPref.prefHasUserValue('visiblemenuitems')) SetQLSPref("visiblemenuitems", QLS_DEFAULT_LOCALES);

		if (!this.oQLSPref.prefHasUserValue('switch_gulocale')) SetQLSPrefBool("switch_gulocale", true);
		if (!this.oQLSPref.prefHasUserValue('switch_accept_languages')) SetQLSPrefBool("switch_accept_languages", true);
		if (!this.oQLSPref.prefHasUserValue('switch_dictionary')) SetQLSPrefBool("switch_dictionary", true);
		if (!this.oQLSPref.prefHasUserValue('hide_tools')) SetQLSPrefBool("hide_tools", false);
		if (!this.oQLSPref.prefHasUserValue('hide_statusbar')) SetQLSPrefBool("hide_statusbar", false);

		if (!this.oQLSPref.prefHasUserValue('useautoswitch'))
		{
			var bUseAuto = true;
			if (GetQLSPrefBool("switch_gulocale")) bUseAuto = false;
			SetQLSPrefBool("useautoswitch", true);
		}
		if (!this.oQLSPref.prefHasUserValue('autoswitchhosts')) SetQLSPref("autoswitchhosts", "");
		if (!this.oQLSPref.prefHasUserValue('fallbacklocale')) SetQLSPref("fallbacklocale", GetQLSPref("locale"));

		if (!this.oQLSPref.prefHasUserValue('switch_alwaysask')) SetQLSPrefBool("switch_alwaysask", false);
		if (!this.oQLSPref.prefHasUserValue('statusbarmode')) SetQLSPref("statusbarmode", "icon");
		if (!this.oQLSPref.prefHasUserValue('autoswitchfortld')) SetQLSPrefBool("autoswitchfortld", true);

		if (!this.oQLSPref.prefHasUserValue('backup_acceptlanguages')) SetQLSPref("backup_acceptlanguages", "");

		this.oDefPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getDefaultBranch("general.useragent.");
		this.sDefaultLocale = GetDefaultLocale();
		if (!this.sDefaultLocale || this.sDefaultLocale == "") this.sDefaultLocale = "en-US";
		if (this.sDefaultLocale.indexOf("-") == -1) this.sDefaultLocale = CCodeToLocale(this.sDefaultLocale);

		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
		oObService.addObserver(this.QLSSettingsObserver, "qls-settings", false); 
		
		var oBrowser = document.getElementById('content');
		if (oBrowser)
		{
			oBrowser.addEventListener("DOMContentLoaded", QLSCheckContentLocale, true);
			oBrowser.addEventListener("blur", QLSSaveLastFocusedElement, true);
			oBrowser.addEventListener("focus", QLSSaveLastFocusedElement, true);
			var oTabs = oBrowser.tabContainer;
			if (!oTabs)
			{
				oTabs = oBrowser.mPanelContainer;
				oTabs.addEventListener("select", QLSCheckContentLocale, false);
			}
			else
			{
				oTabs.addEventListener("TabSelect", QLSCheckContentLocale, false);
			}
		}
	
		ApplySettings();
		InitDefault();
		CheckLocale();
		QLSCheckUpdateURL();
		
		this.QLSIsInitialized = true;
		this.bQLSDisableInstantApply = QLSGetInstantApply();
	}
	var oContent = document.getElementById('content-frame');
	if (oContent)
	{
		oContent.addEventListener("focus", QLSTBCheckAddressField, true);
	}
}

function DeInit()
{
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
	oObService.removeObserver(this.QLSSettingsObserver, "qls-settings"); 
	var oPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
	oPrefService.removeObserver("general.useragent.locale", this.QLSPrefObserver);

	this.QLSPrefObserver = null;
	this.QLSSettingsObserver = null;
}

function QLSCheckUpdateURL()
{
	//Since the automatic update checker checks for updates based on the current locale, it will not find any updates if you have switched to a locale that is not available as translation (or it might even download a "wrong" version).
	//In here we do what is also done in nsUpdateService.js, replacing the %LOCALE% param of the update url, but this time we do it with the default locale, so the locale Firefox/TB was installed in.
	var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch2);
	var sURL = "";
	
	if (!oPrefs.prefHasUserValue('app.update.url.override'))
	{
	    var oDefPrefs = oPrefs.QueryInterface(Components.interfaces.nsIPrefService).getDefaultBranch(null);
		try {sURL = oDefPrefs.getCharPref('app.update.url');}
		catch (e) {}
		oPrefs.setCharPref('app.update.url.override', sURL);
	}
	
	try {sURL = oPrefs.getCharPref('app.update.url.override');}
	catch (e) {}

	if (sURL && sURL != "" && sURL.indexOf("%LOCALE%") >= 0)
	{
		sURL = sURL.replace(/%LOCALE%/g, this.sDefaultLocale);
		oPrefs.setCharPref('app.update.url.override', sURL);
	}	
}

function InitDefault()
{
	if (document.getElementById('taskPopup')) InitDefaultSeamonkey();
	var oMItem;
	var sLabel;

	oMItem = document.getElementById("defaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
	oMItem = document.getElementById("tbdefaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
	oMItem = document.getElementById("sbpdefaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
}

function CheckLocale()
{
	var sLocale = GetQLSPref("locale");
	var oElement = document.getElementById(sLocale);
	var oTBElement = document.getElementById('tb_' + sLocale);
	var oSBPElement = document.getElementById('sbp_' + sLocale);
	if (!oElement)
	{
		var oElements = document.getElementsByAttribute('ccode', sLocale.toLowerCase());
		var iIndex, iLen = oElements.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (oElements[iIndex].nodeName == "menuitem")
			{
				if (oElements[iIndex].id.indexOf('sbp') >= 0) oSBPElement = oElements[iIndex];
				else if (oElements[iIndex].id.indexOf('tb') >= 0) oTBElement = oElements[iIndex];
				else oElement = oElements[iIndex];
			}
		}
	}
	if (!oElement)
	{
		sLocale = GetSeamonkeyLocale()
		oElement = document.getElementById(sLocale);
		oSBPElement = document.getElementById('sbp_' + sLocale);
		
		if (!oElement) oElement = document.getElementsByAttribute('ccode', sLocale.toLowerCase())[0];
	}
	if (oElement)
	{
		oElement.setAttribute("hidden", false);
		oElement.setAttribute("checked", true);
	}
	if (oTBElement)
	{
		oTBElement.setAttribute("hidden", false);
		oTBElement.setAttribute("checked", true);
	}
	if (oSBPElement)
	{
		oSBPElement.setAttribute("hidden", false);
		oSBPElement.setAttribute("checked", true);
	}
	if (document.getElementById("defaultQLS")) document.getElementById("defaultQLS").setAttribute('disabled', sLocale == this.sDefaultLocale);
	if (document.getElementById("tbdefaultQLS")) document.getElementById("tbdefaultQLS").setAttribute('disabled', sLocale == this.sDefaultLocale);
	if (document.getElementById("sbpdefaultQLS")) document.getElementById("sbpdefaultQLS").setAttribute('disabled', sLocale == this.sDefaultLocale);
	QLSInitStatusBar(sLocale);
}

function UnCheckLocale()
{
	var sLocale = GetQLSPref("locale");
	var oElement = document.getElementById(sLocale);
	var oTBElement = document.getElementById('tb_' + sLocale);
	var oSBPElement = document.getElementById('sbp_' + sLocale);
	if (!oElement) oElement = document.getElementsByAttribute('ccode', sLocale.toLowerCase())[0];
	if (!oElement)
	{
		sLocale = GetSeamonkeyLocale()
		oElement = document.getElementById(sLocale);
		if (!oElement) oElement = document.getElementsByAttribute('ccode', sLocale.toLowerCase())[0];
	}
	if (oElement)
	{
		oElement.setAttribute("checked", false);
	}
	if (oTBElement)
	{
		oTBElement.setAttribute("checked", false);
	}
	if (!oSBPElement)
	{
		sLocale = GetSeamonkeyLocale()
		oSBPElement = document.getElementById('sbp_' + sLocale);
	}
	if (oSBPElement)
	{
		oSBPElement.setAttribute("checked", false);
	}
}

function ChangeLocale(sLocale)
{
	var bChangeLocale = true;
	sLocale = sLocale.replace('tb_', '');
	sLocale = sLocale.replace('sbp_', '');
	if (GetQLSPref("locale") == sLocale) return;

	if (GetQLSPrefBool("switch_alwaysask"))
	{
		var oSettings = {gulocale: GetQLSPrefBool("switch_gulocale"), dictionary: GetQLSPrefBool("switch_dictionary"), accept_languages: GetQLSPrefBool("switch_accept_languages"), alwaysask: GetQLSPrefBool("switch_alwaysask"), accepted: false};
		openDialog("chrome://qls/content/qlsaskswitchsettings.xul", "qls-askswitchsettings", "modal,center", oSettings);
		if (oSettings.accepted)
		{
			SetQLSPrefBool("switch_gulocale", oSettings.gulocale);
			SetQLSPrefBool("switch_dictionary", oSettings.dictionary);
			SetQLSPrefBool("switch_accept_languages", oSettings.accept_languages);
			SetQLSPrefBool("switch_alwaysask", oSettings.alwaysask);
		}
		else
		{
			bChangeLocale = false;
			CheckLocale();
		}
	}
	
	if (bChangeLocale)
	{
		SetQLSPref("locale", sLocale);
		CheckLocale();

		if (GetQLSPrefBool("switch_accept_languages")) UpdateAcceptLanguages(sLocale);
		if (GetQLSPrefBool("switch_dictionary")) SwitchSpellCheckerDictionary(sLocale);
		
		if (GetQLSPrefBool("switch_gulocale"))
		{
			SetLocale(sLocale);
			SetQLSPref("fallbacklocale", sLocale);
		
			if (document.getElementById('taskPopup')) ChangeLocaleSeamonkey(sLocale);
			DoLocaleWorkAround();
		}

		if (GetQLSPrefBool("useautoswitch") && (GetQLSPrefBool("switch_dictionary") || GetQLSPrefBool("switch_dictionary")))
		{
			QLSAddHostLocale(sLocale);
		}
	}
}

function QLSChangeContentAndDictionaryLocale(sLocale)
{
	sLocale = sLocale.replace('tb_', '');
	sLocale = sLocale.replace('sbp_', '');

	SetQLSPref("locale", sLocale)
	CheckLocale();
	
	if (GetQLSPrefBool("switch_accept_languages")) UpdateAcceptLanguages(sLocale);
	if (GetQLSPrefBool("switch_dictionary")) SwitchSpellCheckerDictionary(sLocale);
}

function QLSCheckContentLocale(oEvent)
{
	if (GetQLSPrefBool("useautoswitch") && !document.getElementById("addressCol2#1") && !document.getElementById("calendar-content-box"))
	{
		QLSInitHostLocales();
		var sFallbackLocale = GetQLSPref("fallbacklocale");
		var sHost = QLSGetHost(content.location.href);
		var sLocale = "";
		var iIndex, iLen = window.QLSHostToLocale.length;

		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (window.QLSHostToLocale[iIndex][0] == sHost) sLocale = window.QLSHostToLocale[iIndex][1];
		}
		if (sLocale == "")
		{
			if (typeof(gBrowser) == "object")
			{
				var oDocument;
				try {gBrowser.selectedBrowser}
				catch (e) {getBrowser();}
				oDocument = gBrowser.selectedBrowser.docShell.QueryInterface(Components.interfaces.nsIWebNavigation).document.documentElement;
				if (oDocument)
				{
					sLocale = oDocument.getAttribute("lang");
					if (!sLocale || sLocale == "") sLocale = oDocument.getAttribute("xml:lang");
				}
				if (sLocale && sLocale != "" && sLocale.indexOf('-') == -1) sLocale = CCodeToLocale(sLocale);
			}
		}
		if (sLocale == "" && GetQLSPrefBool("autoswitchfortld"))
		{
			//Check the current Top Level Domain.
			var sTLD = sHost.substr(sHost.lastIndexOf(".") + 1);
			if (sTLD != "")
			{
			}
		}

		if (!sLocale || sLocale == "") sLocale = sFallbackLocale;
		
		if (GetQLSPref("locale") != sLocale) UnCheckLocale();
    	QLSChangeContentAndDictionaryLocale(sLocale);
	}
}

function QLSTBCheckAddressField(oField)
{
	if (typeof(awGetInputElement) == "function") oField = awGetInputElement(1);
	if (!oField) oField = document.getElementById("addressCol2#1");
	if (oField)
	{
		var sValue = QLSGetEmailAddress(oField.value);
		if (sValue && sValue != "")
		{
			QLSCheckTBContentLocale(sValue);
		}
	}
}

function QLSGetEmailAddress(sValue)
{
	if (sValue && sValue != "")
	{
		var iPos1 = sValue.indexOf("<");
		var iPos2 = sValue.indexOf(">");
		if (iPos1 >= 0 && iPos2 >= 0) sValue = sValue.substring(iPos1 + 1, iPos2); //Get the e-mail address.
	}
	return sValue;
}

function QLSCheckTBContentLocale(sEmailAddress)
{
	if (GetQLSPrefBool("useautoswitch") && document.getElementById("addressCol2#1"))
	{
		QLSInitHostLocales();
		var sFallbackLocale = GetQLSPref("fallbacklocale");
		var sLocale = "";
		var iIndex, iLen = window.QLSHostToLocale.length;

		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (window.QLSHostToLocale[iIndex][0] == sEmailAddress) sLocale = window.QLSHostToLocale[iIndex][1];
		}

		if (!sLocale || sLocale == "") sLocale = sFallbackLocale;
		
		if (GetQLSPref("locale") != sLocale) UnCheckLocale();
    	QLSChangeContentAndDictionaryLocale(sLocale);
	}
}

function QLSAddHostLocale(sLocale)
{
	QLSInitHostLocales();
	var oField = document.getElementById("addressCol2#1");
	var sHost = QLSGetHost(content.location.href);
	var iIndex;

	if (oField)
	{
		for (iIndex = 1; iIndex < 30; iIndex ++)
		{
			oField = document.getElementById("addressCol2#" + iIndex);
			if (oField)
			{
				sHost = QLSGetEmailAddress(oField.value);
			    QLSAddHostLocaleCheckAndStore(sLocale, sHost);
			}
		}
	}
	else QLSAddHostLocaleCheckAndStore(sLocale, sHost);
}

function QLSAddHostLocaleCheckAndStore(sLocale, sHost)
{
	var iIndex, iLen = window.QLSHostToLocale.length;
	var bFound = false;

	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (window.QLSHostToLocale[iIndex][0] == sHost)
		{
			window.QLSHostToLocale[iIndex][1] = sLocale;
			bFound = true;
		}
	}
	if (!bFound)
	{
		window.QLSHostToLocale[iLen] = new Array();
		window.QLSHostToLocale[iLen][0] = sHost;
		window.QLSHostToLocale[iLen][1] = sLocale;
	}
	QLSStoreHostLocalePref();
	QLSInitHostLocales(true);
}

function QLSStoreHostLocalePref()
{
	var aTemp = new Array();
	var sHostLocale = "";
	var iIndex, iLen = window.QLSHostToLocale.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		aTemp[iIndex] = window.QLSHostToLocale[iIndex].join(';');
	}
	sHostLocale = aTemp.join(' ');
	SetQLSPref("autoswitchhosts", sHostLocale);
}

function QLSInitHostLocales(bForceReCreate)
{
	if (bForceReCreate || !window.QLSHostToLocale)
	{
		window.QLSHostToLocale = null;
		window.QLSHostToLocale = new Array();
		
		var aTmp = GetQLSPref("autoswitchhosts").split(' ');
		var iIndex, iLen = aTmp.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			window.QLSHostToLocale[iIndex] = aTmp[iIndex].split(';');
		}
	}
}

function QLSInitStatusBar(sSelectedLocale)
{
	var oSBPanel, oSBTooltip;
	
	oSBPanel = document.getElementById('statusbar-QLS');
	oSBTooltip = document.getElementById('statusbar-tooltip-QLS-locale');
	if (oSBPanel && oSBTooltip)
	{
		var sDisplayLocale = sSelectedLocale;
		if (!sDisplayLocale || sDisplayLocale == "") sDisplayLocale = "en-US";
		if (sDisplayLocale.indexOf("-") == -1) sDisplayLocale = CCodeToLocale(sDisplayLocale);
		oSBPanel.setAttribute('ccode', sDisplayLocale);
		if (oSBPanel.getAttribute('mode') != GetQLSPref("statusbarmode"))
		{
			oSBPanel.setAttribute('mode', "text");
			//The timeout is necessary because Ff sometimes renders the icon/text in a diffent order (text first/icon first)
			setTimeout('SetStatusBarMode();', 1);
		}
		oSBPanel.childNodes[0].value = sSelectedLocale;
		
		var oElement = document.getElementById(sSelectedLocale);
		if (!oElement) oElement = document.getElementsByAttribute('ccode', sSelectedLocale.toLowerCase())[0];
		if (!oElement)
		{
			sSelectedLocale = GetSeamonkeyLocale()
			oElement = document.getElementById(sSelectedLocale);
			if (!oElement) oElement = document.getElementsByAttribute('ccode', sSelectedLocale.toLowerCase())[0];
		}
		if (oElement)
		{
			oSBTooltip.setAttribute('value', oElement.getAttribute('label'));
		}
	}
}

function SetStatusBarMode()
{
	var oSBPanel = document.getElementById('statusbar-QLS');
	if (oSBPanel) oSBPanel.setAttribute('mode', GetQLSPref("statusbarmode"));
}

function DoLocaleWorkAround()
{
	//Showing about:config seems to solve the problem of not being able to change non-installed locale (often) in Ff 1.0.7 and 1.4
	window.open("chrome://qls/content/qlsreloadchrome.xul", "qlspleasewait", "chrome,close,titlebar,modal,centerscreen"); 
	var oPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var checkResult = {};

	try
	{
		//Auto restart in Ff 1.4 and later.
		var oAppStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup);
		if (!oAppStartup.eRestart) throw("Restart is not supported in Seamonkey...");
		var bAskRestart = this.oQLSPref.getBoolPref("askautorestart");
		if (bAskRestart == true)
		{
			var sTitle = document.getElementById("mCavemanQLS").getAttribute('label');
			var sMsg = document.getElementById("msCavemanQLS2").getAttribute('statustext');
			var sNotify = document.getElementById("msCavemanQLS").getAttribute('statustext');

			var bRestart = oPromptService.confirmCheck(window,sTitle, sMsg, sNotify, checkResult);

			if (checkResult.value) this.oQLSPref.setBoolPref("askautorestart", false);
		}
		if (bRestart == true || bAskRestart == false) oAppStartup.quit(oAppStartup.eAttemptQuit | oAppStartup.eRestart);
	}
	catch (e)
	{
		var bNotify = this.oQLSPref.getBoolPref("notifyrestart")
	
		if (bNotify == true)
		{
			//Show message in other versions.
			if (document.getElementById("mCavemanQLS") && document.getElementById("mpCavemanQLS"))
			{
				var sTitle = document.getElementById("mCavemanQLS").getAttribute('label');
				var sMsg = document.getElementById("mpCavemanQLS").getAttribute('statustext');
				var sNotify = document.getElementById("msCavemanQLS").getAttribute('statustext');

				oPromptService.alertCheck(window, sTitle, sMsg, sNotify, checkResult);
				if (checkResult.value) this.oQLSPref.setBoolPref("notifyrestart", false);
			}
		}
	}
}

function ChangeLocaleSeamonkey(sLocale)
{
	var QLS_InProfile = true;
	
	var oRDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	try {var oDS = oRDF.GetDataSourceBlocking("rdf:chrome");}
	catch (e) {return;}

	var inProfile = oDS.GetTarget(oRDF.GetResource("urn:mozilla:package:qls"), oRDF.GetResource("http://www.mozilla.org/rdf/chrome#locType"), true);
	if (inProfile instanceof Components.interfaces.nsIRDFLiteral && inProfile.Value == "install") QLS_InProfile = false;
	
	try
	{
		var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
		if (!("selectLocaleForPackage" in chromeRegistry)) chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIChromeRegistrySea);
		chromeRegistry.selectLocaleForPackage(sLocale, "qls", QLS_InProfile);
	}
	catch (e) {return;}
}

function InitDefaultSeamonkey()
{
	if (this.sDefaultLocale.length > 10)
	{
		var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
		this.sDefaultLocale = chromeRegistry.getSelectedLocale("global");

		if (("selectLocaleForPackage" in chromeRegistry))
		{
			var QLS_InProfile = true;
			var oRDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
			try {var oDS = oRDF.GetDataSourceBlocking("rdf:chrome");}
			catch (e) {return;}

			var inProfile = oDS.GetTarget(oRDF.GetResource("urn:mozilla:package:mozgest"), oRDF.GetResource("http://www.mozilla.org/rdf/chrome#locType"), true);
			if (inProfile instanceof Components.interfaces.nsIRDFLiteral && inProfile.Value == "install") QLS_InProfile = false;
			var QLSLocale = chromeRegistry.getSelectedLocale("qls");
			chromeRegistry.selectLocaleForPackage(QLSLocale, "qls", QLS_InProfile);	
		}		
	}
}

function OpenSettings()
{
	if (this.bQLSDisableInstantApply) QLSEnableInstantApply(false);
	var bSupportsPrefWindow = false;
	try
	{
		document.getElementById("test_noprefwindow").preferences;
		if (typeof(document.getElementById("test_noprefwindow").preferences) == "undefined") bSupportsPrefWindow = false;
		else bSupportsPrefWindow = true;
	}
	catch (e) {bSupportsPrefWindow = false;}
	if (bSupportsPrefWindow)
	{
		window.openDialog("chrome://qls/content/qlssettings.xul", "qls-settings", "chrome,titlebar,toolbar,centerscreen,modal,resizable");
	}
	else
	{
		window.openDialog("chrome://qls/content/qlssettings_noprefwindow.xul", "qls-settings", "chrome,titlebar,toolbar,centerscreen,modal,resizable");
	}
}

function ApplySettings()
{
	var oParent;
	var oMItem, oTBMItem, oSBPItem;
	var sLabel = "", sLocale = "";
	var bShowSep = false;
	
	oMItem = document.getElementById("qlscustom1");
	oTBMItem = document.getElementById("tbqlscustom1");
	oSBPItem = document.getElementById("sbpqlscustom1");
	sLocale = GetQLSPref("customlocale1");
	sLabel = GetQLSPref("customlabel1");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
		if (oSBPItem)
		{
			oSBPItem.setAttribute("hidden", false);
			oSBPItem.setAttribute("clocale", sLocale);
			oSBPItem.setAttribute("ccode", sLocale.toLowerCase());
			oSBPItem.setAttribute("label", sLabel);
		}
	}
	oMItem = document.getElementById("qlscustom2");
	oTBMItem = document.getElementById("tbqlscustom2");
	oSBPMItem = document.getElementById("sbpqlscustom2");
	sLocale = GetQLSPref("customlocale2");
	sLabel = GetQLSPref("customlabel2");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
		if (oSBPMItem)
		{
			oSBPMItem.setAttribute("hidden", false);
			oSBPMItem.setAttribute("clocale", sLocale);
			oSBPMItem.setAttribute("ccode", sLocale.toLowerCase());
			oSBPMItem.setAttribute("label", sLabel);
		}
	}
	oMItem = document.getElementById("qlscustom3");
	oTBMItem = document.getElementById("tbqlscustom3");
	oSBPMItem = document.getElementById("sbpqlscustom3");
	sLocale = GetQLSPref("customlocale3");
	sLabel = GetQLSPref("customlabel3");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
		if (oSBPMItem)
		{
			oSBPMItem.setAttribute("hidden", false);
			oSBPMItem.setAttribute("clocale", sLocale);
			oSBPMItem.setAttribute("ccode", sLocale.toLowerCase());
			oSBPMItem.setAttribute("label", sLabel);
		}
	}
	
	if (bShowSep == true)
	{
		if (document.getElementById("msCavemanQLS2")) document.getElementById("msCavemanQLS2").setAttribute("hidden", false);
		if (document.getElementById("tbmsCavemanQLS2")) document.getElementById("tbmsCavemanQLS2").setAttribute("hidden", false);
		if (document.getElementById("sbpmsCavemanQLS2")) document.getElementById("sbpmsCavemanQLS2").setAttribute("hidden", false);
	}
	
	var aAllMItems = QLS_ALL_LOCALES.split("#");
	var aMItems = GetQLSPref("visiblemenuitems").split("#");
	var iIndex, iLen;
	
	iLen = aAllMItems.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oMItem = document.getElementById(aAllMItems[iIndex]);
		if (oMItem && oMItem.getAttribute("checked") == false) oMItem.setAttribute("hidden", true);
		oTBMItem = document.getElementById('tb_' + aAllMItems[iIndex]);
		if (oTBMItem && oTBMItem.getAttribute("checked") == false) oTBMItem.setAttribute("hidden", true);
		oSBPMItem = document.getElementById('sbp_' + aAllMItems[iIndex]);
		if (oSBPMItem && oSBPMItem.getAttribute("checked") == false) oSBPMItem.setAttribute("hidden", true);
	}
	iLen = aMItems.length;
	for (iIndex = iLen -1; iIndex > -1; iIndex --)
	{
		oMItem = document.getElementById(aMItems[iIndex]);
		if (oMItem)
		{
			oParent = oMItem.parentNode;
			oParent.removeChild(oMItem);
			oMItem.setAttribute("hidden", false);
			oParent.insertBefore(oMItem, oParent.childNodes[6]);
		}
		oTBMItem = document.getElementById('tb_' + aMItems[iIndex]);
		if (oTBMItem)
		{
			oParent = oTBMItem.parentNode;
			oParent.removeChild(oTBMItem);
			oTBMItem.setAttribute("hidden", false);
			oParent.insertBefore(oTBMItem, oParent.childNodes[6]);
		}
		oSBPMItem = document.getElementById('sbp_' + aMItems[iIndex]);
		if (oSBPMItem)
		{
			oParent = oSBPMItem.parentNode;
			oParent.removeChild(oSBPMItem);
			oSBPMItem.setAttribute("hidden", false);
			oParent.insertBefore(oSBPMItem, oParent.childNodes[6]);
		}
	}

	var oSItem = document.getElementById("statusbar-QLS");
	var oMItem = document.getElementById("mCavemanQLS");
	if (GetQLSPrefBool("hide_statusbar") && oSItem) oSItem.setAttribute("hidden", true);
	else if (oSItem) oSItem.setAttribute("hidden", false);
	if (GetQLSPrefBool("hide_tools") && oMItem) oMItem.setAttribute("hidden", true);
	else if (oMItem) oMItem.setAttribute("hidden", false);
	
	QLSInitHostLocales(true);
	QLSCheckContentLocale();
	setTimeout("QLSTBCheckAddressField();", 500);
	QLSInitStatusBar(GetLocale());
	if (this.bQLSDisableInstantApply) QLSEnableInstantApply(true);
}

function GetLocale()
{
	try {return this.oPref.getComplexValue("locale", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oPref.getCharPref("locale");
}

function GetDefaultLocale()
{
	try {return this.oDefPref.getComplexValue("locale", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oDefPref.getCharPref("locale");
}

function GetSeamonkeyLocale()
{
	var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
	return chromeRegistry.getSelectedLocale("qls");
}

function SetLocale(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oPref.setComplexValue("locale", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function UpdateAcceptLanguages(sData)
{
	var sAL = GetAcceptLanguages();
	var aAL = sAL.split(',');
	var sSearch = sData;
	var iIndex = ArrayIndexOf(aAL, sSearch);
	sSearch = GetCCode(sSearch);
	if (iIndex == -1) iIndex = ArrayIndexOf(aAL, sSearch);

	//Remove lang code from the accept languages.
	while (iIndex >= 0)
	{	
		aAL.splice(iIndex, 1);
		iIndex = ArrayIndexOf(aAL, sSearch);
		if (iIndex == -1)
		{
			sSearch = GetCCode(sSearch);
			iIndex = ArrayIndexOf(aAL, sSearch);
		}
	}
	//Add it at the beginning again, most detailed must come first.
	if (sData.length > sSearch)
	{
		aAL.unshift(sData);
		if (sSearch!= sData) aAL.unshift(sSearch);
	}
	else
	{
		aAL.unshift(sSearch);
		if (sData != sSearch) aAL.unshift(sData);
	}
	sAL = aAL.join(',');
	SetAcceptLanguages(sAL);
}

function SwitchSpellCheckerDictionary(sData)
{
	try
	{
		var oSC = Components.classes['@mozilla.org/spellchecker/myspell;1'].getService(Components.interfaces.mozISpellCheckingEngine);
		var aDictionaries  = {};
		var aCount = {};
		var aLocales;
		var iIndex;

		oSC.getDictionaryList(aDictionaries, aCount);
		aLocales = aDictionaries.value;
		iIndex = ArrayIndexOf(aLocales, sData)
		if (iIndex == -1)
		{
			//Long lang code does not exist, try short one.
			sData = GetCCode(sData);
			iIndex = ArrayIndexOf(aLocales, sData);
		}
		if (iIndex >= 0)
		{
			//Only set if the locale is available cause it will break spell checking if you set a not installed dict.
			oSC.dictionary = sData;
			SetSpellCheckerDictionary(sData);
			//Recheck for thunderbird.
			if (window.content.document && typeof(InlineSpellChecker) == "object") InlineSpellChecker.checkDocument(window.content.document);
			//Recheck for Firefox
			if (typeof(InlineSpellCheckerUI) == "object")
			{
				var oEditor;
				if (!document.commandDispatcher.focusedElement)
				{
					//document.commandDispatcher.focusedElement = this.oLastFocusedElement;
					var oWindow = document.commandDispatcher.focusedWindow;
					var oDS = oWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShell);
					if (typeof oDS.editor == "undefined")
					{
						if (oDS instanceof Components.interfaces.nsIEditorDocShell) oEditor = oDS.editor;
					}
					else oEditor = oDS.editor;					
				}
				else
				{
					oEditor = document.commandDispatcher.focusedElement.QueryInterface(Components.interfaces.nsIDOMNSEditableElement).editor;
				}
				InlineSpellCheckerUI.clearSuggestionsFromMenu();
				InlineSpellCheckerUI.clearDictionaryListFromMenu();
	        	InlineSpellCheckerUI.uninit();
				if (oEditor)
				{
					InlineSpellCheckerUI.init(oEditor);
		    		InlineSpellCheckerUI.mEditor.QueryInterface(Components.interfaces.nsIEditor_MOZILLA_1_8_BRANCH).setSpellcheckUserOverride(true);
				}
			}
		}
	}
	catch (e) {}
}

function QLSSaveLastFocusedElement()
{
	if (document.commandDispatcher.focusedElement) this.oLastFocusedElement = document.commandDispatcher.focusedElement;
}

function GetAcceptLanguages()
{
	var sResult = GetQLSPref("backup_acceptlanguages", "");
	if (!sResult || sResult == "")
	{
		try {sResult = this.oALPref.getComplexValue("accept_languages", Components.interfaces.nsIPrefLocalizedString).data;}
		catch (e) {sResult = "";}
		sResult = this.oALPref.getCharPref("accept_languages");
	}
	SetQLSPref("backup_acceptlanguages", sResult);
	return sResult;
}

function SetAcceptLanguages(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oALPref.setComplexValue("accept_languages", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetSpellCheckerDictionary()
{
	try {return this.oSCPref.getComplexValue("dictionary", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oSCPref.getCharPref("dictionary");
}

function SetSpellCheckerDictionary(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oSCPref.setComplexValue("dictionary", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetQLSPref(sName)
{
	try {return this.oQLSPref.getComplexValue(sName, Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oQLSPref.getCharPref(sName);
}

function SetQLSPref(sName, sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oQLSPref.setComplexValue(sName, Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetQLSPrefBool(sName)
{
	return this.oQLSPref.getBoolPref(sName);
}

function SetQLSPrefBool(sName, bData)
{
	this.oQLSPref.setBoolPref(sName, bData);
}

function ArrayIndexOf(a, s)
{
	var iIndex = -1, iLen = a.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++) if (a[iIndex] == s) return iIndex;
	return -1;
}

function GetCCode(sData)
{
	var iIndex = sData.search('-');
	if (iIndex >= 0) return sData.substring(0, iIndex);
	return sData;
}

function CCodeToLocale(sData)
{
	var sLocale = "";
	var oElement = document.getElementsByAttribute('ccode', sData)[0];
	if (oElement) sLocale = oElement.getAttribute('id');
	sLocale = sLocale.replace('tb_', '');
	sLocale = sLocale.replace('sbp_', '');
	return sLocale;
}

function QLSGetLCode(sData)
{
	var iIndex, iLen, iP1, iP2;
	if (!this.aQLSAllLCodes)
	{
		var aAllMItems = QLS_ALL_LOCALES.split("#");
		iLen = aAllMItems.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			iP1 = aAllMItems[iIndex].indexOf("-") + 1;
			iP2 = aAllMItems[iIndex].lastIndexOf("-");
			if (iP1 == iP2) iP2 = aAllMItems[iIndex].length;
			this.aQLSAllLCodes[iIndex] = aAllMItems[iIndex].substring(iP1, iP2);
		}
	}
}

function QLSGetHost(sURI)
{
	var sHost = sURI;
	
	try
	{
		var oIOS = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
   		var oURI = oIOS.newURI(sURI,null,null);
		oURI.spec = sURI;
		sHost = oURI.host;
	} catch (e) {}

	return sHost;
}

function QLSEnableInstantApply(bEnable)
{
	var oPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.preferences.");
	oPref.setBoolPref("instantApply", bEnable)
}

function QLSGetInstantApply()
{
	try
	{
		var oPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.preferences.");
		return oPref.getBoolPref("instantApply");
	}
	catch (e) {return false;}
}
